/*
If have any problem in using this demo program, please mail to service@icpdas.com
This demo shows some features:
	1. This demo will show the "Firmware Version" , "Lib built date" and Gain/Offset for Calibration of i-8017H/i-8017HS/i-8017HW
		If this demo get wrong AI data for 8017H,8017HS or 8017HW, please send these message to service@icpdas.com
	2. For i-8017HS or i-8017HW, it has two input signal mode, Differential(Isolated)/Single Ended(None Isolated).
		Default is Differential(Isolated).
	3. For old 8017HL.lib it must i8017H_Set_ChannelGainMode before use i8017H_Get_AD_FValue and i8017H_Get_AD_HValue,
		Now it can be done only use i8017H_ReadAI
	4. For i-8000 system, it will spend much time to convert hex value to float format,if performance is the issue,
		it can i8017H_ReadAIHex to get hex data then convert collected data to float.
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include "..\..\..\Lib\8000A.h"
#include "..\..\..\Lib\8017H.h"
char gainStr[5][32]={"+/-10V  ",
					 "+/-5V   ",
					 "+/-2.5V ",
					 "+/-1.25V",
					 "+/-20mA "};
char DSubStr[2][32]={"Close","Open"};

int main(void)
{
	int i=0;
	short jumper=0;
	short firmware=0;
	char libDate[32];
	short DSubStatus=0;
	
	int slot=-1;
	int CHs=8;
	int Gain=0;
	unsigned short gVal=0;
	short oVal=0;
	float fVal=0;
	
	unsigned long T1=0,T3=0;
	
	InitLib();
	for(i=0;i<GetNumberOfSlot();i++){
		if(NameOfModule[i]==17){
			slot=i;
			i8017H_Init(slot);
			break;
		}
	}
	if(slot==-1){
		Print("There is no i-8017H found in slot\n");
		Delay(2000);
		return 0;
	}
	Print("****************************\n");
	Print("This demo show how to read analog input data.\n");
	i8017H_GetFirmwareVersion(slot,&firmware);
	Print("Lattice Version =:0x%04X\n",firmware);
	Print("Library Version =:0x%04X\n",i8017H_GetLibVersion());
	i8017H_GetLibDate(libDate);
	Print("Build Date =: %s\n",libDate);
	i8017H_GetSingleEndJumper(slot,&jumper);
	if(jumper){
		CHs=16;
		Print("I-8017HW/I-8017HCW/I-8017DW Input Mode=Single-End\n");
	}
	else{
		CHs=8;
		Print("I-8017HW/I-8017HCW/I-8017DW Input Mode=Differential\n");
	}
	Print("****************************\n");
	i8017H_Get_D_Sub_Status(slot,&DSubStatus);
	Print("D Sub connector status (For I-8017DW only ) :  %s \n",DSubStr[DSubStatus]);
	Print("Gain\n");
	for(i=0;i<5;i++){
		Print("  %1d = %s, ",i,gainStr[i]);
		i8017H_ReadGainOffset_Info(slot,i,&gVal,&oVal);
		Print("Gain = %5u Offset = %5d \n",gVal,oVal);
	}
	Print("Please choose (0~4):");
	Gain=Getch();
	Print("%c \n",Gain);
	Gain-='0';
	T1=GetTimeTicks();
	for(;;){
		T3=GetTimeTicks();
		if((T3-T1)>1000){ // read frequency every 1000 ms
			T1=T3;
			for(i=0;i<CHs;i++){
				i8017H_ReadAI(slot,i,Gain,&fVal);
				if(i%CHs==CHs-1){
					Print("[%02d:%7.3f]\r",i,fVal);
				}
				else{
					Print("[%02d:%7.3f] ",i,fVal);
				}
			}
		}
		if(Kbhit()){
			i=Getch();
			if((i=='q')||(i=='Q')){
				return 0;
			}
		}
	}
}